#pragma once



class GameLevel
{
public:
	GameLevel();
	~GameLevel();


	//Tile״ı任ʽ
	enum eTileTransform
	{
		eTT_Whole,
		eTT_Top,
		eTT_Left,
		eTT_Right,
		eTT_Bottom,
		eTT_None
	};

	struct TileInfo
	{
		int textureIndex;
		eTileTransform transform;

		void Reset() { textureIndex = -1; transform = eTT_None; }
	};

	//߼
	//༭ؿʱĳͼƬ߼
	enum eGridProperty
	{
		eGridProp_None = -1,
		eGridProp_Breakable,		//ɴݻ
		eGridProp_Unbreakable,		//ɴݻ
		eGridProp_Slidable,			//򻬵..
		eGridProp_Obstacle,			//ϰ
		eGridProp_Invisible,		//ϵ
	};

	typedef std::vector<TileInfo> TileRow;
	typedef std::vector<TileRow> TileContainer;

public:
	void	New();
	void	Save(const char* filename);
	void	Open(const char* filename);

	void							SetResourceDirectory(const CString& dir);
	const std::wstring				GetResFullPath(const char* filename) const;
	const std::vector<CString>&		GetResourceNames() const { return m_vecFileNames; }
	int								GetGridSize() const { return m_gridSize; }
	int								GetTileSize() const { return m_tileSize; }
	int								GetHorizonTileCnt() const { return m_horizonGridCnt / 2; }
	int								GetVerticalTileCnt() const { return m_verticalGridCnt / 2; }
	void							SetGameAreaSize(int w, int h) { m_width = w; m_height = h; }

	void							SetTileTexture(int tileX, int tileY, int texIndex);
	int								GetTileTexture(int tileX, int tileY) const;
	const std::wstring				GetTileTexutreName(int tileX, int tileY) const;
	void							SetTileTransform(int tileX, int tileY, eTileTransform tran);
	const TileInfo&					GetTileInfo(int tileX, int tileY) const;
	void							SetTexutreProp(int texIndex, eGridProperty prop);
	const eGridProperty				GetTextureProp(int texIndex) const;

private:
	int				m_width, m_height;	//Ϸߴ
	int				m_gridSize;			//λӳߴ
	int				m_tileSize;			//һTileΪ2*2,༭ʱTileΪλ
	int				m_horizonGridCnt;	//ˮƽ
	int				m_verticalGridCnt;	//ֱ

	TileContainer	m_vecTileInfo;		//TileϢ

	CString			m_strResourceDir;
	std::vector<CString> m_vecFileNames;
	std::vector<eGridProperty> m_vecProp; //Ӧ߼
};

