
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "LevelEditor.h"
#include "GridEditDlg.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

class CAdjustArea : public CDialog
{
	DECLARE_MESSAGE_MAP()

public:
	CAdjustArea(CWnd* pParent = NULL):CDialog(CAdjustArea::IDD, pParent) {}
	virtual ~CAdjustArea() {}
	int DoModal(int& outW, int& outH) 
	{ 
		int ret = CDialog::DoModal();
		outW = m_width; 
		outH = m_height; 
		return ret;
	}

	enum { IDD = IDD_DialogAdjust };

private:
	afx_msg void OnOK();

	int m_width;
	int m_height;
};

BEGIN_MESSAGE_MAP(CAdjustArea, CDialog)
	ON_COMMAND(IDOK, OnOK)
END_MESSAGE_MAP()

void CAdjustArea::OnOK()
{
	char szWidth[10], szHeight[10];
	GetDlgItemText(IDC_ADJUST_W, szWidth, 10);
	GetDlgItemText(IDC_ADJUST_H, szHeight, 10);

	m_width = ::atoi(szWidth);
	m_height = ::atoi(szHeight);

	CDialog::OnOK();
}

// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_EDIT_ADJUST, OnAdjustArea)
	ON_COMMAND(IDC_SHOW_SELECTOR, OnShowSelector)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	m_wndView.m_pGridEditDlg->OnGameAreaSizeChange();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.style &= ~WS_THICKFRAME;
	cs.lpszClass = AfxRegisterWndClass(0);

	//ʼϷ800*600
	RECT newClientRect;
	newClientRect.left = (::GetSystemMetrics(SM_CXSCREEN) - 800) / 2;
	newClientRect.top = (::GetSystemMetrics(SM_CYSCREEN) - 600) / 2;
	newClientRect.right = newClientRect.left + 800;
	newClientRect.bottom = newClientRect.top +600;

	AdjustWindowRect(&newClientRect, cs.style, TRUE);

	cs.cx = newClientRect.right - newClientRect.left;
	cs.cy = newClientRect.bottom - newClientRect.top;

	return TRUE;
}

// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}
#endif //_DEBUG


// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::OnAdjustArea()
{
	//ȡҪĿͻС
	CAdjustArea dialog;
	int w, h;
	if (IDOK == dialog.DoModal(w, h))
	{
		//е
		RECT newClientRect;
		newClientRect.left = (::GetSystemMetrics(SM_CXSCREEN) - w) / 2;
		newClientRect.top = (::GetSystemMetrics(SM_CYSCREEN) - h) / 2;
		newClientRect.right = newClientRect.left + w;
		newClientRect.bottom = newClientRect.top + h;

		AdjustWindowRect(&newClientRect, WS_OVERLAPPEDWINDOW, TRUE);

		SetWindowPos(NULL, newClientRect.left, newClientRect.top
			, newClientRect.right - newClientRect.left
			, newClientRect.bottom - newClientRect.top
			, 0);

		m_wndView.m_pGridEditDlg->OnGameAreaSizeChange();
	}
}

void CMainFrame::OnShowSelector()
{
	UINT bChecked = GetMenu()->GetMenuState(IDC_SHOW_SELECTOR, MF_BYCOMMAND);
	if(bChecked == MF_CHECKED)
	{
		GetMenu()->CheckMenuItem(IDC_SHOW_SELECTOR, MF_BYCOMMAND | MF_UNCHECKED);
		m_wndView.m_pGridEditDlg->ShowWindow(SW_HIDE);
	}
	else
	{
		GetMenu()->CheckMenuItem(IDC_SHOW_SELECTOR, MF_BYCOMMAND | MF_CHECKED);
		m_wndView.m_pGridEditDlg->ShowWindow(SW_SHOW);
	}
}
