#ifndef APP_STATE_MANAGER_H
#define APP_STATE_MANAGER_H


#include "AppState.h"

/************************************************************************/
/*							״̬								*/
/************************************************************************/

class CAppStateManager : public AppStateListener
{
public:
	struct state_info
	{
		std::string name;
		CAppState* state;
	};

	CAppStateManager();
	virtual ~CAppStateManager();

	//˳Ϸ
	void shutdown();
	//µǰ״̬߼,false˳Ϸ
	bool UpdateCurrentState(float dt);
	//µǰ״̬Ⱦ
	void Render();

	CAppState* getCurState();
	void manageAppState(const std::string& stateName, CAppState* state);
	CAppState* findByName(const std::string& stateName);
	void changeAppState(CAppState* state);
	bool pushAppState(CAppState* state);
	void popAppState();
	void pauseAppState();
    void popAllAndPushAppState(CAppState* state);

protected:
	void _init(CAppState *state);

	std::vector<CAppState*>		m_ActiveStateStack;
	std::vector<state_info>		m_States;
	bool						m_bShutdown;
};


#endif