#ifndef MOVIE_H
#define MOVIE_H

#include "hgevector.h"


class hgeSprite;


/************************************************************************/
/*							¼	                             */
/************************************************************************/
class HgeMovie;

class MovieEventListener
{
public:
	MovieEventListener() {}
	virtual ~MovieEventListener() {}

public:
	virtual void	OnMovieEnd(HgeMovie* pMovie) = 0;
};

/************************************************************************/
/*							ʾЧһ֡                             */
/************************************************************************/

class HgeFrame
{
public:
	HgeFrame(HGE* hge, HTEXTURE tex);
	~HgeFrame();

public:
	HTEXTURE		GetTexture() const { return m_pSprite->GetTexture(); }
	void			Render(const hgeVector& pos);
	hgeSprite*		GetSprite()		{ return m_pSprite; }

private:
	HGE*			m_pHGE;
	hgeSprite*		m_pSprite;
};

/************************************************************************/
/*							Ч	                                */
/************************************************************************/
typedef std::vector<HgeFrame*> MovieFrameVector;

class HgeMovie : public MovieEventListener
{
public:
	HgeMovie(HGE* hge);
	~HgeMovie();

public:
	void				AddFrame(HgeFrame* pFrame);
	void				Clone(HgeMovie& newMovie);
	//öΪѭģʽ,ͬʱָʱ(СڱʱѭЧ)
	//2ʾѭ,Ǵͷʼ
	void				SetLoopInfo(float lifeTime, bool bPingPang);
	//öӴʼ೤ʱſʼ
	void				SetPauseTime(float fTime)	{ m_fPauseTime = fTime; }

	void				SetPos(const hgeVector& pos)	{ m_moviePos = pos; }
	const hgeVector&	Getpos() const		{ return m_moviePos; }
	bool				Update(float dt);
	void				Render();
	void				AddListener(MovieEventListener* listener) { m_eventListenr = listener; }

	virtual void		OnMovieEnd(HgeMovie* pMovie);

private:
	HGE*				m_pHGE;
	MovieFrameVector	m_frames;
	float				m_lifeTime;				//ѭʱ
	float				m_movieLength;			//ʱ
	bool				m_bLoop;
	bool				m_bPingPang;
	bool				m_curPlayDir;			//PingPangģʽǰǷ
	size_t				m_curFrameIndex;
	float				m_existTime;			//ѽʱ
	float				m_curFrameExistTime;	//ǰ֡ѽʱ
	hgeVector			m_moviePos;				//λ
	MovieEventListener*	m_eventListenr;
	float				m_fPauseTime;
};

/************************************************************************/
/*							Ч                                */
/************************************************************************/
typedef std::list<HgeMovie*> MovieList;
typedef std::map<std::string, HgeMovie*> MovieTemplateMap;


class HgeMovieManager
{
public:
	HgeMovieManager();
	~HgeMovieManager();

public:
	void		InitMovieTemplate(const std::string& resPath);
	void		Shutdown();
	HgeMovie*	PlayMovie(const std::string& name, const hgeVector& pos);
	//ж
	void		Update(float dt);
	//Ⱦж
	void		Render();
	//ǿɱжʵ
	void		KillAllInstances();

private:
	HGE*				m_pHGE;
	MovieTemplateMap	m_movieTemplates;	//ģ
	MovieList			m_movies;			//ʵ
	std::vector<HTEXTURE> m_vecTex;			//жͼƬ
};


#endif