#include "stdafx.h"
#include "PlayingState.h"
#include "MenuState.h"
#include "World.h"
#include "hgefont.h"



std::string CPlayingState::StateName = "DrivingState";

CPlayingState::CPlayingState():
m_fPrologTime(0),
m_pFont(NULL),
m_bGameOver(false)
{
	m_pHGE = hgeCreate(HGE_VERSION);
}

CPlayingState::~CPlayingState()
{
	SAFE_RELEASE(m_pHGE);
	SAFE_DELETE(m_pFont);
}

void CPlayingState::enter()
{
	if(!m_pFont)
	{
		m_pFont = new hgeFont("Media\\font1.fnt");
		m_pFont->SetScale(1.5f);
	}
	//лؿĻ
	m_pHGE->Effect_Play(World::GetSingleton().GetObjectManager().m_startSound);
	m_fPrologTime = 5.0f;
	m_bGameOver = false;
}

bool CPlayingState::pause()
{
    return true;
}

void CPlayingState::resume()
{
	
}

void CPlayingState::exit()
{
	World::GetSingleton().GetLevelManager().LeaveCurrentLevel();
}

void CPlayingState::update(float timeSinceLastFrame)
{
	if(!m_bGameOver && World::GetSingleton().GetGameOver())
	{
		//ͣ2ٽGameOver
		static float fPassTime = 0;
		fPassTime += timeSinceLastFrame;
		if (fPassTime > 2)
		{
			m_pHGE->Effect_Play(World::GetSingleton().GetObjectManager().m_gameOverSound);
			m_fPrologTime = 3.0f;
			
			m_bGameOver = true;
			fPassTime = 0;
		}
	}
	else if(m_fPrologTime > 0)
	{
		m_fPrologTime -= timeSinceLastFrame;
		if(m_fPrologTime <= 0)
		{
			if(!World::GetSingleton().GetLevelManager().EnterNextLevel())
			{
				World::GetSingleton().SetGameOver(false);
				changeAppState(findByName(CMenuState::StateName));
			}
		}
	}
    else if(!World::GetSingleton().UpdateWolrd())
	{
		changeAppState(findByName(CPlayingState::StateName));
	}
}

void CPlayingState::render()
{
	if(m_fPrologTime > 0)
	{
		if(m_bGameOver)
		{
			m_pHGE->Gfx_Clear(0xffffffff);
			m_pFont->SetColor(0xffff0000);
			m_pFont->printf((RESOLUTIONX+HUDX)/2.0f, RESOLUTIONY/2.0f-50, HGETEXT_CENTER, "Game Over");
		}
		else
		{
			m_pHGE->Gfx_Clear(0xffffffff);
			m_pFont->SetColor(0xff000000);
			const int levelIndex = World::GetSingleton().GetLevelManager().GetCurrentLevelIndex();
			m_pFont->printf((RESOLUTIONX+HUDX)/2.0f, RESOLUTIONY/2.0f-50, HGETEXT_CENTER, "Level %d", levelIndex+2);
		}
	}
	else
	{
		World::GetSingleton().RenderWorld();
	}
}
