#include "stdafx.h"
#include "AppStateManager.h"
#include "MenuState.h"
#include "PauseState.h"
#include "PlayingState.h"
#include "World.h"
#include <time.h>


bool FrameFunc();
bool RenderFunc();

/************************************************************************/
/*							Ӧó									*/
/************************************************************************/
class Applicaton
{
public:
	bool	Init();
	void	Run();
	void	Shutdown();

public:
	HGE*				m_pHGE;
	CAppStateManager	m_stateMgr;
};

bool Applicaton::Init()
{
	//ʼ
	srand( (unsigned)time( NULL ) );

	//״̬
	CMenuState::create(&m_stateMgr, CMenuState::StateName);
	CPlayingState::create(&m_stateMgr, CPlayingState::StateName);
	CPauseState::create(&m_stateMgr, CPauseState::StateName);

	//ʼHGE
	m_pHGE = hgeCreate(HGE_VERSION);
	if(!m_pHGE)
		return false;

	m_pHGE->System_SetState(HGE_LOGFILE, "game.log");
	m_pHGE->System_SetState(HGE_FRAMEFUNC, FrameFunc);
	m_pHGE->System_SetState(HGE_RENDERFUNC, RenderFunc);
	m_pHGE->System_SetState(HGE_TITLE, "TankWar");
	m_pHGE->System_SetState(HGE_FPS, FPS);
	m_pHGE->System_SetState(HGE_WINDOWED, true);
	m_pHGE->System_SetState(HGE_SCREENWIDTH, RESOLUTIONX+HUDX);
	m_pHGE->System_SetState(HGE_SCREENHEIGHT, RESOLUTIONY);
	m_pHGE->System_SetState(HGE_SCREENBPP, 32);

	if(!m_pHGE->System_Initiate())
		return false;

	if(!World::GetSingleton().InitWorld())
	{
		m_pHGE->System_Log("ʼWorldʧ!\n");
		return false;
	}

	return true;
}

void Applicaton::Run()
{
	//˵
	m_stateMgr.changeAppState(m_stateMgr.findByName(CMenuState::StateName));

	m_pHGE->System_Start();
}

void Applicaton::Shutdown()
{
	World::GetSingleton().DestroyWorld();
	m_stateMgr.shutdown();
	m_pHGE->System_Shutdown();
	m_pHGE->Release();
	m_pHGE = nullptr;
}

//ȫӦó
Applicaton g_app;


bool FrameFunc()
{
	float dt = g_app.m_pHGE->Timer_GetDelta();

	// Process keys
	if (g_app.m_pHGE->Input_GetKeyState(HGEK_ESCAPE)) return true;

	//Ϸ״̬
	if(!g_app.m_stateMgr.UpdateCurrentState(dt))
		return true;

	return false;
}


bool RenderFunc()
{
	// Render graphics
	g_app.m_pHGE->Gfx_BeginScene();
	g_app.m_pHGE->Gfx_Clear(0);

	g_app.m_stateMgr.Render();

	g_app.m_pHGE->Gfx_EndScene();

	return false;
}


int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	if(g_app.Init())
	{
		g_app.Run();
	}
	g_app.Shutdown();
	
	return 0;
}
