#ifndef BULLET_H
#define BULLET_H


#include "Object.h"


class hgeSprite;
class Tank;

/************************************************************************/
/*								ӵ	                                */
/************************************************************************/

class Bullet : public Object
{
public:
	Bullet(hgeSprite* pSpr);
	virtual ~Bullet();

public:
	virtual eObjectType	GetType() const { return m_sType; }
	virtual void		Update();
	virtual void		OnDestroy();
	virtual float		GetObjectSize() const;

public:
	void				SetOwner(Tank* pOwner)		{ m_pOwner = pOwner; }
	void				SetIsFromEnemy(bool bEnemy) { m_bFromEnemy = bEnemy; }
	bool				GetIsFromEnemy() const		{ return m_bFromEnemy; }
	void				SetSpeed(const hgeVector& speed) { m_speed = speed; }
	const hgeVector&	GetSpeed() const { return m_speed; }
	float				GetSize() const;
	eDirection			GetDirection() const;

private:
	static eObjectType	m_sType;
	bool				m_bFromEnemy;	//Ƿǵ˷ӵ
	hgeVector			m_speed;
	Tank*				m_pOwner;		//ӵķ
};


#endif