#ifndef LEVEL_MANAGER
#define LEVEL_MANAGER

#include "GameDefine.h"
#include "hgevector.h"
#include "Movie.h"


typedef std::pair<HTEXTURE, eTileProp> TextureInfoPair;
typedef std::vector<TextureInfoPair> TexContainer;
typedef std::vector<int> TileRow;
typedef std::vector<TileRow> TileIdxVector;

/************************************************************************/
/*								ؿ	                                */
/************************************************************************/

class Level
{
public:
	Level();
	~Level();

public:
	bool	LoadLevel(const std::string& path);
	void	EnterLevel();
	void	LeaveLevel();
	void	SetRemainingEnemyCnt(int cnt) { m_remainingEnemies = cnt; }
	int		GetRemainingEnemyCnt() const { return m_remainingEnemies; }

private:
	HGE*			m_pHGE;

	TexContainer	m_vecTexs;
	TileIdxVector	m_vecTileTexIdx;
	int				m_remainingEnemies;	//ؿʣ
};

/************************************************************************/
/*							ؿ	                                */
/*					ؿͳ,,л								*/
/************************************************************************/

class LevelManager : public MovieEventListener
{
public:
	LevelManager();
	~LevelManager();

public:
	virtual void	OnMovieEnd(HgeMovie* pMovie);

public:
	void	Reset();
	//عؿļейؿ
	bool	LoadAllLevels(const std::string& levelPath);
	//һؿ,false˵ͨ
	bool	EnterNextLevel();
	//ǰؿ
	void	LeaveCurrentLevel();
	//
	void	AddPlayerLife() { ++m_remainingLives; }

	int		GetCurrentLevelIndex() const { return m_curLevel; }
	int		GetPlayerLife() const		{ return m_remainingLives; }
	int		GetRemainingEnemyCount() const { return m_vecLevels[m_curLevel].GetRemainingEnemyCnt(); }
	void	OnEnemyDestroy();
	void	OnPlayerBeenShot();

private:
	std::vector<Level>	m_vecLevels;
	int					m_curLevel;
	int					m_remainingLives;	//ʣ̹
};


#endif