#ifndef OBJECT_H
#define OBJECT_H

#include "GameDefine.h"
#include "hgevector.h"
#include "hgerect.h"


class hgeSprite;


/************************************************************************/
/*							Ϸ	                                */
/************************************************************************/

class Object
{
public:
	Object(hgeSprite* pSprite);
	virtual ~Object();

public:
	virtual eObjectType GetType() const = 0;
	virtual void		Update() = 0;
	virtual	void		Render();
	virtual void		OnDestroy() {}
	virtual float		GetObjectSize() const = 0;

public:
	//עжλõĸı䶼ͨӿڽ,ΪΧеļLazy-Init.
	void				SetPos(const hgeVector& pos);
	const hgeVector&	GetPos() const { return m_pos; }
	void				SetVisible(bool bVisible)	{ m_bVisible = bVisible; }
	const hgeRect&		GetBoundingBox() const;	

protected:
	hgeVector	m_pos;
	hgeSprite*	m_pSprite;
	bool		m_bVisible;
	mutable hgeRect	m_boundingBox;
	mutable bool m_boundingBoxDirty;
};


#endif