#ifndef OBJECT_MANAGER_H
#define OBJECT_MANAGER_H

#include "Object.h"
#include "GameDefine.h"
#include "Movie.h"



class hgeSprite;
typedef std::list<Object*> ObjectList;

/************************************************************************/
/*							Ϸ                                */
/************************************************************************/

class ObjectManager
{
public:
	ObjectManager();
	~ObjectManager();

public:
	//Ϸ
	Object*				CreateObject(hgeSprite* pSpr, eObjectType type);
	//
	void				DestroyObject(Object* pObj);
	//
	void				DestroyAllObjects();
	//Ⱦ
	void				Render();
	//߼
	void				Update();

	void				LoadRes();
	void				UnloadRes();
	const ObjectList&	GetObjects() const { return m_lstObjects; }

private:
	ObjectList			m_lstObjects;	//Ϸ

public:
	HGE*				m_pHGE;
	HTEXTURE			m_texTank;
	HTEXTURE			m_texBullet;
	HTEXTURE			m_texEnemyBullet;
	HTEXTURE			m_texEnemy1;
	HTEXTURE			m_texEnemy2;
	HTEXTURE			m_texFlag;
	HTEXTURE			m_texFlagBroken;
	HTEXTURE			m_texHUDTank;
	HEFFECT				m_fireSound;
	HEFFECT				m_hitSound;
	HEFFECT				m_blastSound;
	HEFFECT				m_startSound;
	HEFFECT				m_gameOverSound;
	HEFFECT				m_itemBornSound;
	HEFFECT				m_bombSound;
	HEFFECT				m_addLifeSound;

	std::vector<HTEXTURE> m_vecItemTexs;

	hgeSprite*			m_pHUDTankSpr;
	hgeSprite*			m_pFlag;
};


#endif