#ifndef TANK_H
#define TANK_H


#include "Object.h"
#include "GameDefine.h"



class hgeSprite;
class Bullet;

/************************************************************************/
/*								̹	                                */
/************************************************************************/

class Tank : public Object
{
public:
	Tank(hgeSprite* pSpr);
	virtual ~Tank();

public:
	virtual eObjectType	GetType() const { return m_sType; }
	virtual void		Update();
	virtual void		Render();
	virtual void		OnDestroy();
	virtual float		GetObjectSize() const { return TANK_SIZE; }

public:
	void				SetDirection(eDirection dir);
	eDirection			GetDirection() const { return m_direction; }
	//ӵ,öӵʧǰ,ܷһö
	void				Shoot();
	//ǰӵʧǰ֪ͨص
	void				OnNotifyBulletDead();
	void				SetIsEnemy(bool bEnemy) { m_bIsEnemy = bEnemy; }
	bool				GetIsEnemy() const		{ return m_bIsEnemy; }

private:
	static eObjectType	m_sType;
	eDirection			m_direction;
	bool				m_bIsEnemy;
	bool				m_bCanShoot;
	hgeVector			m_speed;
	float				m_restTime;
	float				m_moveTime;
	float				m_shootTime;
	float				m_curTime;
	bool				m_bIsMove;
	Bullet*				m_pActiveBullet;
};


#endif