#include "stdafx.h"
#include "Object.h"
#include "World.h"





Object::Object( hgeSprite* pSprite ):
m_pSprite(pSprite),
m_bVisible(true),
m_boundingBoxDirty(true)
{

}

Object::~Object()
{
	SAFE_DELETE(m_pSprite);
}

void Object::Render()
{
	if(m_bVisible)
		m_pSprite->Render(m_pos.x, m_pos.y);
}

void Object::SetPos( const hgeVector& pos )
{
	m_pos = pos;
	m_boundingBoxDirty = true;
}

const hgeRect& Object::GetBoundingBox() const
{
	if(m_boundingBoxDirty)
	{
		m_boundingBox.x1 = m_pos.x;	
		m_boundingBox.y1 = m_pos.y; 
		m_boundingBox.x2 = m_pos.x + GetObjectSize();	
		m_boundingBox.y2 = m_pos.y + GetObjectSize(); 
		
		m_boundingBoxDirty = false;
	}

	return m_boundingBox;
}
